// MT Engine MK2
// Copyleft 2014 the Mojon Twins

// enems.h
// Enemy management, new style

// Ninjajar Clouds not supported, sorry!
// Type 5 "random respawn" not supported sorry! (but easily punchable!)

// There are new, more suitable defines now.
// ENABLE_FLYING_ENEMIES
// ENABLE_LINEAR_ENEMIES
// ENABLE_PURSUE_ENEMIES
// ENABLE_SHOOTERS

#if defined (ENABLE_FLYING_ENEMIES) || defined (ENABLE_SHOOTERS) || defined (ENABLE_HANNA_MONSTERS_11)
unsigned char distance (unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2) {
	unsigned char dx = abs (x2 - x1);
	unsigned char dy = abs (y2 - y1);
	unsigned char mn = dx < dy ? dx : dy;
	return (dx + dy - (mn >> 1) - (mn >> 2) + (mn >> 4));
}
#endif

#if defined(ENABLE_HANNA_MONSTERS_11)
// TODO: add light/torch stuff here!
unsigned char i_can_see_you (void) {
	return (distance (gpx, gpy, gpen_cx, gpen_cy) <= HANNA_MONSTERS_11_SIGHT);
}
#endif

#ifdef ENABLE_SHOOTERS
unsigned char coco_x [MAX_COCOS], coco_y [MAX_COCOS], coco_s [MAX_COCOS], ctx, cty;
signed char coco_vx [MAX_COCOS], coco_vy [MAX_COCOS];
void __FASTCALL__ init_cocos (void) {
	for (gpit = 0; gpit < MAX_COCOS;) coco_s [gpit++] = 0;
}

unsigned char coco_it, coco_d, coco_x0;
void __FASTCALL__ shoot_coco (void) {
	coco_x0 = gpen_cx + 4;
#ifdef TYPE_8_FIRE_ONE
	coco_it = gpit;
	{
#else
	for (coco_it = 0; coco_it < MAX_COCOS; coco_it ++) {
#endif
		if (coco_s [coco_it] == 0) {
			coco_d = distance (coco_x0, gpen_cy, gpx, gpy);
			if (coco_d >= TYPE_8_SAFE_DISTANCE) {
#ifdef MODE_128K
				wyz_play_sound (3);
#endif
				coco_s [coco_it] = 1;
				coco_x [coco_it] = coco_x0;
				coco_y [coco_it] = gpen_cy;

				coco_vx [coco_it] = (COCO_SPEED_8 * (gpx - coco_x0) / coco_d);
				coco_vy [coco_it] = (COCO_SPEED_8 * (gpy - gpen_cy) / coco_d);
			}
		}
	}
}

void __FASTCALL__ move_cocos (void) {
	for (coco_it = 0; coco_it < MAX_COCOS; coco_it ++) {
		if (coco_s [coco_it]) {
			coco_x [coco_it] += coco_vx [coco_it];
			coco_y [coco_it] += coco_vy [coco_it];

			if (coco_x [coco_it] >= 240 || coco_y [coco_it] >= 160) coco_s [coco_it] = 0;
			// Collide player
			ctx = coco_x [coco_it] + 3;
			cty = coco_y [coco_it] + 3;
			if (p_estado == EST_NORMAL) {
				if (collide_pixel (ctx, cty, gpx, gpy)) {
					coco_s [coco_it] = 0;
#ifdef MODE_128K
						kill_player (7);
#else
						kill_player (4);
#endif
				}
			}
		}
	}
}
#endif

#ifdef ENABLE_RANDOM_RESPAWN
char player_hidden (void) {
	gpxx = gpx >> 4;
	gpyy = gpy >> 4;
	if ( (gpy & 15) == 0 && p_vx == 0 ) {
		if (attr (gpxx, gpyy) == 2 || (attr (1 + gpxx, gpyy) == 2 && (gpx & 15)) ) {
			return 1;
		}
	}
	return 0;
}
#endif

#if defined (ENABLE_HANNA_MONSTERS_11)
unsigned char player_hidden (void) {
	gpxx = (gpx + 8) >> 4; gpyy = (gpy + 8) >> 4;
	return (attr (gpxx, gpyy) & 2);
}
#endif

#ifdef WALLS_STOP_ENEMIES
unsigned char __FASTCALL__ mons_col_sc_x (void) {
	gpaux = gpen_xx + (baddies [enoffsmasi].mx > 0);
#ifdef EVERYTHING_IS_A_WALL
	return (attr (gpaux, gpen_yy) || ((baddies [enoffsmasi].y & 15) && attr (gpaux, gpen_yy + 1)));
#else
	return (attr (gpaux, gpen_yy) & 8 || ((baddies [enoffsmasi].y & 15) && attr (gpaux, gpen_yy + 1) & 8));
#endif
}

unsigned char __FASTCALL__ mons_col_sc_y (void) {
	gpaux = gpen_yy + (baddies [enoffsmasi].my > 0);
#ifdef EVERYTHING_IS_A_WALL
	return (attr (gpen_xx, gpaux) || ((baddies [enoffsmasi].x & 15) && attr (gpen_xx + 1, gpaux)));
#else
	return (attr (gpen_xx, gpaux) & 8 || ((baddies [enoffsmasi].x & 15) && attr (gpen_xx + 1, gpaux) & 8));
#endif
}
#endif

#if defined(SLOW_DRAIN) && defined(PLAYER_BOUNCES)
unsigned char lasttimehit;
#endif

#if defined(ENABLE_FLYING_ENEMIES) || defined(ENABLE_RANDOM_RESPAWN)
int limit (int val, int min, int max) {
	if (val < min) return min;
	if (val > max) return max;
	return val;
}
#endif

unsigned char pregotten;
#if defined (ENABLE_SHOOTERS) || defined (ENABLE_ARROWS)
unsigned char enemy_shoots;
#endif
void mueve_bicharracos (void) {
#if defined (PHANTOMAS_ENGINE) || defined (HANNA_ENGINE)
	gpx = p_x >> 6;
	gpy = p_y >> 6;
#endif
#ifndef PLAYER_MOGGY_STYLE
	p_gotten = 0;
	ptgmx = 0;
	ptgmy = 0;
#endif

	tocado = 0;
	p_gotten = 0;
	for (gpit = 0; gpit < 3; gpit ++) {
		active = killable = animate = 0;
		enoffsmasi = enoffs + gpit;
		gpen_x = baddies [enoffsmasi].x;
		gpen_y = baddies [enoffsmasi].y;

		if (en_an_state [gpit] == GENERAL_DYING) {
			en_an_count [gpit] --;
			if (0 == en_an_count [gpit]) {
				en_an_state [gpit] = 0;
				en_an_next_frame [gpit] = sprite_18_a;
				continue;
			}
		}

#ifndef PLAYER_MOGGY_STYLE
		// Gotten preliminary:
#if defined (BOUNDING_BOX_8_CENTERED) || defined (BOUNDING_BOX_8_BOTTOM)
		pregotten = (gpx + 11 >= baddies [enoffsmasi].x && gpx <= baddies [enoffsmasi].x + 11);
#else
		pregotten = (gpx + 15 >= baddies [enoffsmasi].x && gpx <= baddies [enoffsmasi].x + 15);
#endif
#endif

#if defined (ENABLE_SHOOTERS) || defined (ENABLE_ARROWS)
		if (baddies [enoffsmasi].t & 4) {
			enemy_shoots = 1;
		} else enemy_shoots = 0;
#endif
		gpt = baddies [enoffsmasi].t >> 3;

		switch (gpt) {
#ifdef ENABLE_PATROLLERS
			case 1:			// linear
				killable = 1;
			case 8:			// moving platforms
				#include "engine/enemmods/move_linear.h"
				break;
#endif
#ifdef ENABLE_FLYING_ENEMIES
			case 2:			// flying
				#include "engine/enemmods/move_fanty.h"
				break;
#endif
#ifdef ENABLE_PURSUERS
			case 3:			// pursuers
				#include "engine/enemmods/move_pursuers.h"
				break;
#endif
#ifdef ENABLE_DROPS
			case 9:			// drops
				#include "addons/drops/move.h"
				break;
#endif
#ifdef ENABLE_ARROWS
			case 10:		// arrows
				#include "addons/arrows/move.h"
				break;
#endif
#ifdef ENABLE_HANNA_MONSTERS_11
			case 11:		// Hanna monsters type 11
				#include "engine/enemmods/move_hanna_11.h"
				break;
#endif
			default:
				if (gpt > 15) en_an_next_frame [gpit] = sprite_18_a;
		}

		if (active) {
			if (animate) {
				#include "engine/enemmods/animate.h"
			}

			// Carriable box launched and hit...
#ifdef ENABLE_FO_CARRIABLE_BOXES
#ifdef CARRIABLE_BOXES_THROWABLE
			#include "engine/enemmods/throwable.h"
#endif
#endif

#if defined(PLAYER_CAN_PUNCH) || defined(PLAYER_HAZ_SWORD)
			#include "engine/enemmods/hitter.h"
#endif

			// Collide with player
#if !defined (PLAYER_MOGGY_STYLE) && !defined (DISABLE_PLATFORMS)
			// Platforms: 2013 rewrite!
			// This time coded in a SMARTER way...!
			if (gpt == 8) {
#if defined (PHANTOMAS_ENGINE) || defined (HANNA_ENGINE)
				if (pregotten && (p_gotten == 0) && (p_saltando == 0 || p_cont_salto > 2)) {
#else
				if (pregotten && (p_gotten == 0) && (p_saltando == 0)) {
#endif
					// Horizontal moving platforms
					if (baddies [enoffsmasi].mx) {
						if (gpy + 16 >= baddies [enoffsmasi].y && gpy + 10 <= baddies [enoffsmasi].y) {
							p_gotten = 1;
#if defined (PHANTOMAS_ENGINE) || defined (HANNA_ENGINE)
							ptgmx = baddies [enoffsmasi].mx;
							p_x += ptgmx;
							p_y = (baddies [enoffsmasi].y - 16); gpy = p_y;
							p_saltando = 0;
#else
							ptgmx = baddies [enoffsmasi].mx << 6;
							p_y = (baddies [enoffsmasi].y - 16) << 6; gpy = p_y >> 6;
#endif
						}
					}

					// Vertical moving platforms
					if (
						(baddies [enoffsmasi].my < 0 && gpy + 18 >= baddies [enoffsmasi].y && gpy + 10 <= baddies [enoffsmasi].y) ||
						(baddies [enoffsmasi].my > 0 && gpy + 17 + baddies [enoffsmasi].my >= baddies [enoffsmasi].y && gpy + 10 <= baddies [enoffsmasi].y)
					) {
						p_gotten = 1;
#if defined (PHANTOMAS_ENGINE) || defined (HANNA_ENGINE)
						ptgmy = baddies [enoffsmasi].my;
						p_y = baddies [enoffsmasi].y - 16; gpy = p_y;
						p_saltando = 0;
#else
						ptgmy = baddies [enoffsmasi].my << 6;
						p_y = (baddies [enoffsmasi].y - 16) << 6; gpy = p_y >> 6;
						p_vy = 0;
#endif
					}
				}
			} else if ((tocado == 0) && collide (gpx, gpy, gpen_cx, gpen_cy) && p_estado == EST_NORMAL) {
#else
			if ((tocado == 0) && collide (gpx, gpy, gpen_cx, gpen_cy) && p_estado == EST_NORMAL) {
#endif
#ifdef PLAYER_KILLS_ENEMIES
				// Step over enemy
				if (
#ifdef PLAYER_CAN_KILL_FLAG
					flags [PLAYER_CAN_KILL_FLAG] &&
#endif
#if defined (PLAYER_HAS_SWIM) && defined (SWITCHABLE_ENGINES)
					p_engine != SENG_SWIM &&
#endif
					gpy < gpen_cy - 2 && p_vy >= 0 && baddies [enoffsmasi].t >= PLAYER_MIN_KILLABLE && killable) {

					en_an_next_frame [gpit] = sprite_17_a;
#ifdef MODE_128K
					wyz_play_sound (6);
					en_an_state [gpit] = GENERAL_DYING;
					en_an_count [gpit] = 8;
#else
					sp_MoveSprAbs (sp_moviles [gpit], spritesClip, en_an_next_frame [gpit] - en_an_current_frame [gpit], VIEWPORT_Y + (gpen_cy >> 3), VIEWPORT_X + (gpen_cx >> 3), gpen_cx & 7, gpen_cy & 7);
					en_an_current_frame [gpit] = en_an_next_frame [gpit];
					sp_UpdateNow ();
					peta_el_beeper (5);
					en_an_next_frame [gpit] = sprite_18_a;
#endif
					baddies [enoffsmasi].t |= 128;			// Mark as dead
#ifdef BODY_COUNT_ON
					flags [BODY_COUNT_ON] ++;
#else
					p_killed ++;
#endif					
#ifdef ACTIVATE_SCRIPTING
#ifdef RUN_SCRIPT_ON_KILL
#ifdef EXTENDED_LEVELS
					if (level_data->activate_scripting) {
#endif
						run_script (2 * MAP_W * MAP_H + 5);
#ifdef EXTENDED_LEVELS
					}
#endif
#endif
#endif

				} else if (p_life > 0) {
#else
				if (p_life > 0) {
#endif
					tocado = 1;
#if defined(SLOW_DRAIN) && defined(PLAYER_BOUNCES)
					if ((lasttimehit == 0) || ((maincounter & 3) == 0)) {
#ifdef MODE_128K
						kill_player (7);
#else
						kill_player (4);
#endif
					}
#else
#ifdef MODE_128K
					kill_player (7);
#else
					kill_player (4);
#endif
#endif
#ifdef TYPE_6_KILL_ON_TOUCH
					if (gpt == 2) {
						en_an_next_frame [gpit] = sprite_18_a;
						baddies [enoffsmasi].t |= 128;
					}
#endif
#ifdef PLAYER_BOUNCES
#ifndef PLAYER_MOGGY_STYLE

					p_vx = addsign (baddies [enoffsmasi].mx, PLAYER_MAX_VX << 1);
					p_vy = addsign (baddies [enoffsmasi].my, PLAYER_MAX_VX << 1);

#else
					if (baddies [enoffsmasi].mx) {
						p_vx = addsign (gpx - gpen_cx, abs (baddies [enoffsmasi].mx) << 8);
					}
					if (baddies [enoffsmasi].my) {
						p_vy = addsign (gpy - gpen_cy, abs (baddies [enoffsmasi].my) << 8);
					}
#endif
#endif
				}
			}

#ifdef PLAYER_CAN_FIRE
			// Collide with bullets
#ifdef FIRE_MIN_KILLABLE
			if (baddies [enoffsmasi].t >= FIRE_MIN_KILLABLE) {
#endif
				for (gpjt = 0; gpjt < MAX_BULLETS; gpjt ++) {
					if (bullets_estado [gpjt] == 1) {
						blx = bullets_x [gpjt] + 3;
						bly = bullets_y [gpjt] + 3;
						if (blx >= gpen_cx && blx <= gpen_cx + 15 && bly >= gpen_cy && bly <= gpen_cy + 15) {
#ifdef ENABLE_FLYING_ENEMIES
							if (gpt == 2) {
								en_an_vx [gpit] += addsign (bullets_mx [gpjt], 128);
							}
#endif
							baddies [enoffsmasi].x = gpen_x;
							baddies [enoffsmasi].y = gpen_y;
							en_an_next_frame [gpit] = sprite_17_a;
							en_an_morido [gpit] = 1;
							bullets_estado [gpjt] = 0;
							if (killable) baddies [enoffsmasi].life --;

							if (baddies [enoffsmasi].life == 0) {
								sp_MoveSprAbs (sp_moviles [gpit], spritesClip, en_an_next_frame [gpit] - en_an_current_frame [gpit], VIEWPORT_Y + (gpen_cy >> 3), VIEWPORT_X + (gpen_cx >> 3), gpen_cx & 7, gpen_cy & 7);
								en_an_current_frame [gpit] = en_an_next_frame [gpit];
								sp_UpdateNow ();
#ifdef MODE_128K
								#asm
									halt
								#endasm
								wyz_play_sound (6);
#else
								peta_el_beeper (5);
#endif
								en_an_next_frame [gpit] = sprite_18_a;
								if (gpt != 7) baddies [enoffsmasi].t |= 128;
#ifdef BODY_COUNT_ON								
								flags [BODY_COUNT_ON] ++;
#else
								p_killed ++;
#endif
#ifdef ENABLE_PURSUERS
								en_an_alive [gpit] = 0;
								en_an_dead_row [gpit] = DEATH_COUNT_EXPRESSION;
#endif

#ifdef ACTIVATE_SCRIPTING
#ifdef RUN_SCRIPT_ON_KILL
								run_script (2 * MAP_W * MAP_H + 5);
#endif
#endif
							}
						}
					}
				}
#ifdef FIRE_MIN_KILLABLE
			}
#endif
#endif

		}
	}
#if defined(SLOW_DRAIN) && defined(PLAYER_BOUNCES)
	lasttimehit = tocado;
#endif
}
